﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Linq;

namespace AllButOneProduct
{
	public class AllButOneProductFastRightLeftScan
	{
		public static int[] CalcProductsWithFastRightLeftScan(int[] input)
		{
			if (input.Length == 0)
			{
				return input;
			}

			int[] products = new int[input.Length];
			// from left-to-right calculate products of all entries to left of each index
			CalcLeftProducts(input, products);
			// from right-to-left multiply in products of all entries to right of each index
			CombineRightProducts(input, products);

			return products;
		}

		private static void CalcLeftProducts(int[] p, int[] products)
		{
			int partialProduct = 1;
			products[0] = partialProduct;
			for (int i = 1; i < p.Length; ++i)
			{
				partialProduct *= p[i - 1];
				products[i] = partialProduct;
			}
		}

		private static void CombineRightProducts(int[] p, int[] products)
		{
			int partialProduct = 1;
			products[products.Length-1] *= partialProduct;
			for (int i = products.Length - 2; i >= 0; --i)
			{
				partialProduct *= p[i+1];
				products[i] *= partialProduct;
			}
		}
	}
}
