﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Linq;

namespace AllButOneProduct
{
	public class AllButOneProductFromLeftRightProducts
	{
		public static int[] CalcProductsFromLeftRightProducts(int[] input)
		{
			if ( input.Length == 0)
			{
				return input;
			}
			// products of all entries to left of each index
			var leftProducts = CalcLeftProducts(input);
			// products of all entries to right of each index
			var rightProducts = CalcRightProducts(input);
			// multiply left and right products to get product of all entries except that at each index
			return leftProducts.Zip(rightProducts, (n, m) => n * m).ToArray();
		}

		private static int[] CalcLeftProducts(int[] input)
		{
			int[] leftProducts = new int[input.Length];
			int partialProduct = 1;
			leftProducts[0] = partialProduct;
			for (int i = 1; i < input.Length; ++i)
			{
				partialProduct *= input[i-1];
				leftProducts[i] = partialProduct;
			}
			return leftProducts;
		}

		private static int[] CalcRightProducts(int[] input)
		{
			int[] rightProducts = new int[input.Length];
			int partialProduct = 1;
			rightProducts[rightProducts.Length-1] = partialProduct;
			for (int i = input.Length-2; i >= 0; --i)
			{
				partialProduct *= input[i+1];
				rightProducts[i] = partialProduct;
			}
			return rightProducts;
		}
	}
}
