﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace AllButOneProduct
{
	public class AllButOneProductTiming
	{
		public static long[] CalcProductsNSquaredTimes(int max, int repeats)
		{
			TimingRun timer = new TimingRun(repeats);

			return timer.TimeRuns((n) => AllButOneProductNSquared.CalcProductsNSquared(CreateIncrementingArray(n)), max);
		}

		public static long[] CalcProductsWithDivisionTimes(int max, int repeats)
		{
			TimingRun timer = new TimingRun(repeats);

			return timer.TimeRuns((n) => AllButOneProductWithDivision.CalcProductsWithDivision(CreateIncrementingArray(n)), max);
		}

		public static long[] CalcProductsFromLeftRightProductsTimes(int max, int repeats)
		{
			TimingRun timer = new TimingRun(repeats);

			return timer.TimeRuns((n) => AllButOneProductFromLeftRightProducts.CalcProductsFromLeftRightProducts(CreateIncrementingArray(n)), max);
		}

		public static long[] CalcProductsWithFastRightLeftScanTimes(int max, int repeats)
		{
			TimingRun timer = new TimingRun(repeats);

			return timer.TimeRuns((n) => AllButOneProductFastRightLeftScan.CalcProductsWithFastRightLeftScan(CreateIncrementingArray(n)), max);
		}

		private static int[] CreateIncrementingArray(int n, int start = 1)
		{
			int[] a = new int[n];
			for ( int i = 0;  i < n;  ++i)
			{
				a[i] = start++;
			}
			return a;
		}
	}
}
