﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Diagnostics;

using WiredPrairie.Silverlight;

namespace AllButOneProduct
{
	public class TimingRun
	{
		const int DEFAULT_REPEATS = 10;

		int repeats;

		public TimingRun(int repeats = 0)
		{
			this.repeats = repeats > 0 ? repeats : DEFAULT_REPEATS;
		}

		public long[] TimeRuns(Action<int> calcFunc, int max)
		{
			long[] times = new long[max + 1];
			for (int i = 0; i <= max; ++i)
			{
				times[i] = TimeOneRun(calcFunc, i);
			}
			return times;
		}

		private long TimeOneRun(Action<int> calcFunc, int i)
		{
			Stopwatch sw1 = Stopwatch.StartNew();
		
			for (int j = 0; j < repeats; ++j)
			{
				calcFunc(i);
			}
			
			sw1.Stop();
			return sw1.ElapsedMilliseconds;
		}
	}
}
