﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Silverlight.Testing;
using Microsoft.VisualStudio.TestTools.UnitTesting;

using AllButOneProduct;

namespace AllButOneProductTest
{
	[TestClass]
	public class AllButOneProductTimingTests
	{
		const int MAX = 100;
		const int REPEATS = 1000;

		public void Test(string testDescription, Func<int, int, long[]> timingFunc, int max, int repeats)
		{
			long[] times = timingFunc(max, repeats);
			Assert.IsTrue(times[0] <= times[times.Length - 1]);
		}


		[TestMethod]
		public void CalcProductsNSquaredTimes()
		{
			Test("CalcProductsNSquaredTimes", AllButOneProductTiming.CalcProductsNSquaredTimes, MAX, REPEATS/10);
		}

		[TestMethod]
		public void CalcProductsWithDivisionTimes()
		{
			Test("CalcProductsWithDivisionTimes", AllButOneProductTiming.CalcProductsWithDivisionTimes, MAX, REPEATS);
		}

		[TestMethod]
		public void CalcProductsFromLeftRightProductsTimes()
		{
			Test("CalcProductsFromLeftRightProductsTimes", AllButOneProductTiming.CalcProductsFromLeftRightProductsTimes, MAX, REPEATS);
		}

		[TestMethod]
		public void CalcProductsWithFastRightLeftScanTimes()
		{
			Test("CalcProductsWithFastRightLeftScanTimes", AllButOneProductTiming.CalcProductsWithFastRightLeftScanTimes, MAX, REPEATS);
		}

	}
}