﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Silverlight.Testing;
using Microsoft.VisualStudio.TestTools.UnitTesting;

using AllButOneProduct;

namespace AllButOneProductTest
{
	[TestClass]
	public class CalcProductsWithFastRightLeftScanTests
	{
		[TestMethod]
		public void Create()
		{
			AllButOneProductNSquared o = new AllButOneProductNSquared();
		}

		public void Test(string testDescription, Func<int[], int[]> productFunc, int[] input, int[] expectedProducts)
		{
			CollectionAssert.AreEqual(expectedProducts, productFunc(input), testDescription);
		}


		[TestMethod]
		public void EmptyArray_GivesEmptyArray()
		{
			Test("CalcProductsWithFastRightLeftScan_EmptyArray_GivesEmptyArray", AllButOneProductFastRightLeftScan.CalcProductsWithFastRightLeftScan, 
				new int[] { }, new int[] { });
		}

		[TestMethod]
		public void ArraySize1_GivesArrayWith1()
		{
			Test("CalcProductsWithFastRightLeftScan_ArraySize1_GivesArrayWith1", AllButOneProductFastRightLeftScan.CalcProductsWithFastRightLeftScan, 
				new int[] { 3 }, new int[] { 1 });
		}

		[TestMethod]
		public void ArraySize2_GivesSwappedArray()
		{
			Test("CalcProductsWithFastRightLeftScan_ArraySize2_GivesSwappedArray", AllButOneProductFastRightLeftScan.CalcProductsWithFastRightLeftScan, 
				new int[] { 3, 4 }, new int[] { 4, 3 });
		}

		[TestMethod]
		public void ArraySize3_GivesCorrectProducts()
		{
			Test("CalcProductsWithFastRightLeftScan_ArraySize3_GivesCorrectProducts", AllButOneProductFastRightLeftScan.CalcProductsWithFastRightLeftScan, 
				new int[] { 3, 4, 5 }, 
				new int[] { 20/*4*5*/, 15/*3*5*/, 12/*3*4*/ });
		}

		[TestMethod]
		public void ArraySize10_GivesCorrectProducts()
		{
			Test("CalcProductsWithFastRightLeftScan_ArraySize3_GivesCorrectProducts", AllButOneProductFastRightLeftScan.CalcProductsWithFastRightLeftScan, 
				new int[] { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 },
				// each result all of input except current entry
				new int[] { 3628800, 3628800 / 2, 3628800 / 3, 3628800 / 4, 3628800 / 5, 
					3628800 / 6, 3628800 / 7, 3628800 / 8, 3628800 / 9, 3628800/10 });
		}

	}
}